<?php
/**
 * This file is part of
 * pragmaMx - Web Content Management System.
 * Copyright by pragmaMx Developer Team - http://www.pragmamx.org
 *
 * pragmaMx is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * $Revision: 1.17.2.6.2.16 $
 * $Author: tora60 $
 * $Date: 2009/12/30 13:01:56 $
 */

defined('mxMainFileLoaded') or die('access denied');

$GLOBALS["module_name"] = basename(dirname(__FILE__));

$ThemeSel = mxGetTheme();
require_once("themes/$ThemeSel/theme.php");
// ################ Einstell Variablen ############################################################################
$GLOBALS["buddylistrefresh"] = 30000; # Refresh Wenn Buddy alleine laeuft
$GLOBALS["buddycheckpm"] = 6000; # Refresh Wenn Buddy alleine laeuft
$GLOBALS["showAdminPrefix"] = "*"; # kleiner Zusatztext hinter dem Adminnamen (funktioniert nur wenn selfAdmin installiert ist)
// User, die nicht angezeigt werden sollen
// Namen mit Komma trennen!
$GLOBALS["excludedusers"] = "Texster, Knaxller";
// #################################################################################################################
// Link verwendet in Sprachdateien
if (!defined('_PMSBBCODELINK')) define('_PMSBBCODELINK', "<a href=\"#\" onclick=\"window.open('modules.php?name=" . $module_name . "&amp;file=bbcode','pmbbcode','width=640, height=480, left=10, top=10, scrollbars=yes, resizable=yes, toolbar=no, location=no, status=no, menubar=no'); return false;\" style=\"cursor: help;\">");

include_once(PMX_MODULES_DIR . DS . $GLOBALS["module_name"] . "/config.php");
include_once(PMX_MODULES_DIR . DS . $GLOBALS["module_name"] . "/bbfunctions.php");
include_once(PMX_MODULES_DIR . DS . $GLOBALS["module_name"] . "/functions.php");
mxGetLangfile($GLOBALS["module_name"]);

$GLOBALS["userinfo"] = array();
$totalmembers = 0;

if (!MX_IS_USER) {
    notloggedin();
    exit;
}

$GLOBALS["userinfo"] = mxGetUserData();
// SQL-bedingung fuer excluded Users erstellen
$exusers = explode (",", $GLOBALS["excludedusers"]);
if (!MX_IS_ADMIN) {
    while (list($key, $val) = each($exusers)) {
        $xexusers[] = trim($val);
    }
}
$xexusers[] = $GLOBALS['anonymous'];
$GLOBALS["excludedusers"] = "'" . implode("','", mxAddSlashesForSQL($xexusers)) . "'";

function create_headerforall($pagetitle)
{
    echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
    echo "<html>\n<head>\n";
    echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=" . _CHARSET . "\">\n";
    echo "<meta http-equiv=\"content-language\" content=\"" . _DOC_LANGUAGE . "\">\n";
    echo "<meta http-equiv=\"Page-Enter\" content=\"revealTrans(Duration=0.1,Transition=23)\">\n";
    echo "<meta http-equiv=\"expires\" content=\"0\">\n";
    echo "<meta http-equiv=\"pragma\" content=\"no-cache\">\n";
    echo "<title>" . $pagetitle . "</title>\n";
    echo '<link rel="stylesheet" type="text/css" href="layout/style/style.css.php?t=' . $ThemeSel . '" />', "\n";
    echo '<link rel="stylesheet" type="text/css" href="themes/' . $ThemeSel . '/style/style.css" />', "\n";
}

function create_bodyforall($extensions = "") // schliesst <head> und oeffnet <body>
{
    echo "\n", '</head><body class="allone popup" style="margin:0;">', "\n";
}

function pmSetOnline() // schliesst <head> und oeffnet <body>
{
    global $prefix, $user_prefix;
    $last = mxSessionGetVar("lasttime"); // Zurcksetzen, damit Online ausgefhrt wird
    $past = time() - MX_SETINACTIVE_MINS ;
    // $GLOBALS["mxSqlDebug"]      = 1;
    if ($last <= $past) {
        if ($GLOBALS["dbtype"] == "MySQL") sql_query("LOCK TABLES {$user_prefix}_users WRITE");
        $qry = "UPDATE {$user_prefix}_users set user_lastvisit=" . time() . " where uname='" . mxAddSlashesForSQL($GLOBALS['userinfo']['uname']) . "'";
        $result = sql_query($qry);
        if ($GLOBALS["dbtype"] == "MySQL") sql_query("UNLOCK TABLES");
        mxSessionSetVar("lasttime", time());
    }
}

function get_userslist($mode)
{
    global $prefix, $user_prefix;
    if ($mode == "all") {
        $qry = "SELECT DISTINCT a.aid, u.uname
FROM {$user_prefix}_users AS u
LEFT JOIN ${prefix}_authors AS a
ON u.uid = a.user_uid
WHERE u.uname Not In (" . $GLOBALS["excludedusers"] . ") AND u.user_stat=1;";
    } else {
        pmSetOnline();
        $past = time() - MX_SETINACTIVE_MINS ;
        $qry = "SELECT DISTINCTROW a.aid, u.uname
FROM {$user_prefix}_users AS u
LEFT JOIN ${prefix}_authors AS a
ON u.uid = a.user_uid
WHERE (((u.uname) Not In (" . $GLOBALS["excludedusers"] . ")
And (u.uname) Is Not Null)
AND (u.user_stat=1)
AND (u.user_lastvisit >= " . $past . ")
AND (u.user_lastmod<>'logout'));";
    }
    $result = sql_query($qry);
    while (list($adminname, $uname) = sql_fetch_row($result)) {
        $showname = (empty($adminname)) ? $uname : " " . $adminname . " " . $GLOBALS["showAdminPrefix"];
        $showname = mxCutString($showname, 20, "..", ""); # Kurzen Usernamen erstellen
        $out[ucfirst($showname) . "&nbsp;"] = $uname;
    }
    if (isset($out)) {
        ksort($out);
        return $out;
    } else {
        return array();
    }
}

function create_footerforall()
{
    echo "</body>\n</html>";
}

function compose($to, $subject, $to_userid = 0)
{
    global $module_name, $prefix, $user_prefix;
    $selectfield = "subject";
    if (empty($to_userid)) {
        $res = sql_query("SELECT uid, uname FROM {$user_prefix}_users WHERE uname='" . mxAddSlashesForSQL($to) . "'");
        list($to_userid, $to_user) = sql_fetch_row($res);
    }
    if ($subject) {
        $subject = mxStripSlashes($subject);
        $subject = msg_desmile($subject);
        $subject = str_replace("" . _PMSRE . ": " . _PMSRE . ": ", _PMSRE . ": ", $subject);
        $selectfield = "msg_text";
    }
    $extensions = " onload=\"document.pmsubmit." . $selectfield . ".focus(); document.pmsubmit." . $selectfield . ".select();\"";
    create_headerforall(_PMSTITLE);
    create_bodyforall($extensions);
    /* PM Begrenzung */
    global $url_images;
    $status = mxPmBoxstatus();
    $sendbox = $status['send'];

    if ($sendbox['limit'] && $sendbox['error']) {
        echo "<br /><br /><br /><br /><br /><center><b>" . _SENTPMBOXVOLL . "</b></center>";
        create_footerforall();
        exit;
    }

    $status = mxPmBoxstatus($to_userid);
    $getbox_recipient = $status['get'];

    if ($getbox_recipient['limit'] && $getbox_recipient['error']) {
        echo "<br /><br /><br /><br /><br /><center><b>" . _EMPFPMBOXVOLL . "</b></center>";
        create_footerforall();
        exit;
    }
    /* Ende PM Begrenzung */
    echo "
<form action=\"modules.php?name=" . $GLOBALS['module_name'] . "\" method=\"post\" target=\"_self\" name=\"pmsubmit\">
<table cellspacing=\"1\" cellpadding=\"0\" class=\"bgcolor1 full\" style=\"height: 100%;\"><tr><td align=\"center\">
" . _PMSSENDM . "<b> $to</b><br /><br />
<table cellspacing=\"1\" cellpadding=\"3\" class=\"bgcolor2 full\">
<tr><td valign=\"top\"><b>" . _PMSSUBJECT . "</b></td>\n<td>\n<input type=\"text\" name=\"subject\" size=\"45\" maxlength=\"50\" value=\"" . mxEntityQuotes($subject) . "\" class=\"popupinput\" /></td>\n</tr>
<tr><td valign=\"top\"><b>" . _PMSMESSAGE . "</b></td>\n<td>\n<textarea id=\"message\" name=\"message\" cols=\"44\" rows=\"4\" class=\"popupinput\"></textarea></td></tr>
";
    if ($GLOBALS['smilies_in_buddy']) {
        echo '<tr><td>
<script type="text/javascript" src="' . PMX_JAVASCRIPT_PATH . 'unb_lib/unb_common.js"></script>
<script type="text/javascript" src="' . PMX_JAVASCRIPT_PATH . 'unb_lib/unb_lib.js"></script>
<script type="text/javascript">
/* <![CDATA[ */
    var textbox = getel("message");
    UnbGlobalRegisterKeyHandler(13, 0, 2);
/* ]]> */
</script>
';
        echo '</td><td>' . printbuddysmilies() . '</td></tr>';
    }
    echo '
</table>
' . _PMSSAVE . '<input type="checkbox" checked="checked" name="save_copy" value="1" style="background-color: transparent;">
<br /><center>
<input type="hidden" name="name" value="' . $GLOBALS['module_name'] . '" />
<input type="hidden" name="file" value="buddy" />
<input type="hidden" name="to_userid" value="' . $to_userid . '" />
<input type="hidden" name="op" value="send" />
<input type="hidden" name="to" value="' . mxEntityQuotes($to_user) . '" />
<input type="image" src="' . $url_images . '/mail_new.png" style="background-color: transparent; border: none;" />
<input type="image" ' . _PMSSUBMIT . '" />
<a href="javascript:window.close()" onclick="window.close()">' . mxCreateImage($url_images . '/cancel.png', '', 0, 'style="background-color: transparent;"') . ' ' . _PMSCANCELSEND . '</a>
</center>
</td></tr></table></form>';
    create_footerforall();
}

function sendm($to, $to_userid, $msg_text, $subject)
{
    global $prefix, $user_prefix;

    /* Senderdaten */
    $sender = mxGetUserData();

    /* Empfaengerdaten */
    $recipient = mxGetUserDataFromUid($to_userid);

    /* PM Begrenzung */
    global $url_images;
    $status = mxPmBoxstatus($recipient['uid']);
    $getbox_recipient = $status['get'];

    $status = mxPmBoxstatus($sender['uid']);
    $sendbox = $status['send'];
    /* Ende PM Begrenzung */

    $timeout = 15000;

    switch (true) {
        case empty($recipient['uid']):
            $msg = _ERRMSGNOUSER;
            break;
        case (!$msg_text):
            $msg = _ERRMSGNOMESSAGE;
            break;
        case mxPmIsRecipientIgnored($recipient['uid'], $sender['uid']):
            /* ignore Funktion */
            $msg = $recipient['uname'] . ' ' . _NOMESSAGE;
            break;
        case ($getbox_recipient['limit'] && $getbox_recipient['error']):
            /* PM Begrenzung */
            $msg = _EMPFPMBOXVOLL;
            break;
        case ($sendbox['limit'] && $sendbox['error']):
            /* PM Begrenzung */
            $msg = _SENTPMBOXVOLL;
            break;
        default:
            $subject = strip_tags($subject);
            if (!$subject) {
                $subject = _PMNOSUBJECT;
            }

            $qry = "INSERT INTO {$prefix}_priv_msgs (msg_image, subject, from_userid, to_userid, msg_time, msg_text)
                            VALUES ('" . mxAddSlashesForSQL($GLOBALS["subjectdefaulticon"]) . "', '" . mxAddSlashesForSQL($subject) . "', '" . intval($sender["uid"]) . "', '" . intval($to_userid) . "', now(), '" . mxAddSlashesForSQL($msg_text) . "')";
            if (sql_query($qry)) {
                $msg = _PMSSENDED1 . " " . $to . " " . _PMSSENDED2;
                $timeout = 1000;

                /* Gesendete PMS speichern */
                if (isset($_POST['save_copy'])) {
                    $newid = sql_insert_id();
                    $qry = "INSERT INTO {$prefix}_priv_msgs_send (msg_id, msg_image, subject, from_userid, to_userid, msg_time, msg_text)
                                    VALUES (" . intval($newid) . ", '" . mxAddSlashesForSQL($GLOBALS["subjectdefaulticon"]) . "', '" . mxAddSlashesForSQL($subject) . "', '" . intval($sender["uid"]) . "', '" . intval($to_userid) . "', now(), '" . mxAddSlashesForSQL($msg_text) . "')";
                    $qry = sql_query($qry);
                    // mxDebugFuncVars(intval($qry));
                }

                /* Email bei neuer PN wenn User offline ist */
                mxPmMailNote($recipient, $sender);
            } else {
                $msg = _PMSBUDDYERROR;
                if (MX_IS_ADMIN) {
                    $msg .= '<br /><br />' . mysql_error();
                }
            }
    }

    create_headerforall(_PMSTITLE);
    create_bodyforall();
    echo "<br /><br />\n";
    echo "<table cellspacing=\"1\" cellpadding=\"0\" class=\"bgcolor1 full\"><tr><td align=\"center\">\n";
    echo "<table cellspacing=\"1\" cellpadding=\"3\" class=\"bgcolor2 full\">\n";
    echo "<tr><td align=\"center\">\n<br />\n<b><br /><b>" . $msg . "</b><br /><br />\n";
    echo '<a href="javascript:window.close()" onclick="window.close()">' . mxCreateImage($url_images . '/cancel.png', '', 0, 'style="background-color: transparent;"') . ' ' . _PMSCLOSE . '</a><br /><br />';
    echo "<font class=\"tiny\">" . _PMSAUTOCLOSE . "</font><br /><br />\n";
    echo "<script type=\"text/javascript\">\n";
    echo "/* <![CDATA[ */\n";
    echo "  setTimeout(\"self.close()\", " . $timeout . ");\n";
    echo "/* ]]> */\n";
    echo "</script>";
    echo "</td>\n</tr>\n</table>\n</td>\n</tr>\n</table>\n";
    create_footerforall();
}

function readm($msg_id)
{
    global $prefix, $user_prefix;
    $msg_id = (int)$msg_id;
    $qry = "SELECT p.*, UNIX_TIMESTAMP(p.msg_time) as msgtimestamp , u.uname, u.user_avatar
            FROM {$prefix}_priv_msgs AS p
            LEFT JOIN {$user_prefix}_users AS u
            ON p.from_userid = u.uid
            WHERE (msg_id=$msg_id)
            AND (to_userid=" . intval($GLOBALS["userinfo"]["uid"]) . ")
            ";
    $result = sql_query($qry);
    $row = sql_fetch_array($result);
    if (empty($row["msg_id"])) { // falls Nachricht in Zwischenzeit geloescht..
        closewindow();
    } else {
        $delcheck = (MX_IS_ADMIN) ? '' : ' checked="checked"';

        $replysubject = msg_desmile($row["subject"]);
        $row["subject"] = strip_tags($row["subject"]);
        $row["subject"] = msg_smile($row["subject"]);

        $row["msg_text"] = pmPrepDisplay($row["msg_text"]);

        $row["msgtimestamp"] = mx_strftime(_PMSTIMESTRING, $row["msgtimestamp"]);
        sql_query("UPDATE {$prefix}_priv_msgs SET read_msg='1' WHERE msg_id='" . $row["msg_id"] . "'");
        create_headerforall(_PMSTITLE);
        create_bodyforall();
        echo "<table cellspacing=\"1\" cellpadding=\"0\" class=\"bgcolor1 full\" style=\"height: 100%;\"><tr><td align=\"center\">\n";
        echo "<br />\n" . _PMSINCOME . " <b>" . $row["uname"] . "</b><br /><br />\n";
        echo "<table cellspacing=\"1\" cellpadding=\"3\" class=\"bgcolor2 full\">\n";
        echo '<tr><td align="right" width="10%">' . mxCreateImage($GLOBALS['url_icons'] . '/' . $row['msg_image'], '', 0, 'align="left"') . '<b>' . _PMSSUBJECT . '</b>:</td><td width="90%">' . msg_smile($row['subject']) . '</td></tr>';
        echo "<tr valign=\"top\"><td align=\"right\"><b>" . _PMSMESSAGE . "</b>:</td>\n<td class=\"bgcolor1\"><font class=\"content\">\n" . $row["msg_text"] . "</font></td>\n</tr>\n";
        echo "<tr><td align=\"right\"><b>" . _PMSSENT . "</b>:</td>\n<td>\n<font class=\"tiny\">" . $row["msgtimestamp"] . "</font></td>\n</tr>\n";
        echo "</table>\n";
        // Buttons
        echo "<form name=\"act\" action=\"modules.php?name=" . $GLOBALS['module_name'] . "\" target=\"_self\" method=\"post\" style=\"border: 0px; margin-top: 5px; margin-bottom: 5px;\">";
        echo "<input type=\"hidden\" name=\"name\" value=\"" . $GLOBALS["module_name"] . "\" />";
        echo "<input type=\"hidden\" name=\"file\" value=\"buddy\" />";
        echo "<input type=\"hidden\" name=\"op\" value=\"compose\" />";
        echo "<input type=\"hidden\" name=\"to\" value=\"" . mxEntityQuotes($row["uname"]) . "\" />";
        echo "<input type=\"hidden\" name=\"subject\" value=\"" . mxEntityQuotes($replysubject) . "\" />";
        echo "" . _PMSDELETE . " <input type=\"checkbox\" name=\"deletemsg\" value=\"1\" " . $delcheck . " style=\"background-color: transparent;\" /> ";
        echo "<input type=\"submit\" name=\"replymsg\" value=\"" . _PMSREPLY . "\" /> ";
        echo "<input type=\"submit\" name=\"closewin\" value=\"" . _PMSCLOSE . "\" /> ";
        echo "<input type=\"hidden\" name=\"msg_id\" value=\"" . (int)$msg_id . "\" />";
        echo "</form>\n";
        echo "</td>\n</tr>\n</table>\n";
        create_footerforall();
    }
}

function checkmsg()
{
    global $prefix;
    if (!MX_IS_USER) return;
    $left = 390;
    $top = 150;
    $qry = "SELECT msg_id, from_userid FROM {$prefix}_priv_msgs WHERE (to_userid='" . intval($GLOBALS["userinfo"]["uid"]) . "') AND (read_msg='0');";
    $result = sql_query($qry);
    while (list($msg_id, $from_userid) = sql_fetch_row($result)) {
        if (empty($from_userid)) { // fehlerhaft gesendete Messages loeschen
            $qry = "DELETE FROM {$prefix}_priv_msgs WHERE (from_userid is null or from_userid <=1);";
            sql_query($qry);
        }
        if (!empty($msg_id)) {
            echo "<script type=\"text/javascript\">\n/* <![CDATA[ */\n";
            echo "\n	window.open('modules.php?name=" . $GLOBALS["module_name"] . "&file=buddy&op=read&msg_id=" . $msg_id . "', '" . md5($msg_id . time()) . "', 'toolbar=0, scrollbars=1, location=0, statusbars=0, menubar=0, resizable=1, width=" . $GLOBALS['buddymsg_width'] . ", height=" . $GLOBALS['buddymsg_height'] . ", top=$top, left=$left');\n";
            echo "\n/* ]]> */\n</script>\n";
            $left = $left + 20;
            $top = $top + 20;
        }
    }
}

function onlycheckmsg($refreshtime)
{
    if (!MX_IS_USER) return;
    echo "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.01 Transitional//EN\">\n";
    echo "<html><head><title>check-pm</title>\n";
    echo "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=" . _CHARSET . "\">\n";
    echo "<meta http-equiv=\"content-language\" content=\"" . _DOC_LANGUAGE . "\">\n";
    echo "<meta http-equiv=\"expires\" content=\"0\">\n";
    echo "<meta http-equiv=\"pragma\" content=\"no-cache\">\n";
    if ($refreshtime > 0) {
        pmSetOnline();
        create_refreshJS($refreshtime);
    }
    checkmsg();
    echo "</head>\n<body></body>\n</html>";
}

function create_composeJS()
{
    echo "
<script type=\"text/javascript\">
/* <![CDATA[ */
function prvmsgto(IM) {
    window.open('modules.php?name=" . $GLOBALS["module_name"] . "&file=buddy&op=compose&to='+IM, '" . md5(time() . "compo") . "','left=370,top=150,width=" . $GLOBALS['buddymsg_width'] . ",height=" . $GLOBALS['buddymsg_height'] . ",toolbar=no,location=no,menubar=no,scrollbars=yes,resizable=yes,status=no');
}
/* ]]> */
</script>\n";
}

function buddy($mode = "online")
{
    global $prefix, $user_prefix;
    $filebuddyfoot = "modules.php?name=" . $GLOBALS["module_name"] . "&amp;file=buddy&amp;op=check&amp;ref_intervall=" . $GLOBALS["buddycheckpm"];
    if ($mode == "online") {
        $img = mxCreateImage($GLOBALS['url_images'] . '/guy_hand.gif', _PMSNOWON, 0, 'align="middle" style="background-color: transparent;"') . mxCreateImage($GLOBALS['url_images'] . '/girl_hand.gif', _PMSNOWON, 0, 'align="middle" style="background-color: transparent;"');
        $linking = "<b>" . _PMSNOWON . "</b></td><td nowrap=\"nowrap\" align=\"center\">" . $img . "</td><td nowrap=\"nowrap\" align=\"center\"><a href=\"modules.php?name=" . $GLOBALS["module_name"] . "&amp;file=buddy&amp;op=allusers\" target=\"_self\">" . _PMSALLUSERS . "</a>";
        $winheigth = 290;
    } else {
        $img = mxCreateImage($GLOBALS['url_images'] . '/people.gif', _PMSALLUSERS, 0, 'align="middle" style="background-color: transparent;"');
        $linking = "<b>" . _PMSALLUSERS . "</b></td><td nowrap=\"nowrap\" align=\"center\">" . $img . "</td><td nowrap=\"nowrap\" align=\"center\"><a href=\"modules.php?name=" . $GLOBALS["module_name"] . "&amp;file=buddy&amp;op=list\" target=\"_self\">" . _PMSNOWON . "</a>";
        $winheigth = 350;
    }
    $listing = get_userslist($mode);

    $ref = "";

    foreach($listing as $showname => $uname) {
        $newref = substr($showname, 0, 1);
        $newref = ($newref == " ") ? "Admins" : $newref;
        $link = "";
        if ($ref != $newref) {
            $ref = $newref;
            $refs[] = "<a href=\"#" . $newref . "\">" . $newref . "</a>";
            $link = " name=\"" . $newref . "\"";
        }
        $out[] = "<li>&nbsp;<A href=\"javascript:prvmsgto('" . $uname . "')\" style=\"text-decoration : none;\"" . $link . ">" . $showname . "</a>";
    }
    $listing = "";
    if (isset($out)) {
        $listing = implode("\n", $out);
        $ref = implode("&nbsp;\n", $refs);
    }

    create_headerforall($GLOBALS["sitename"]);
    create_composeJS();
    create_bodyforall(); # style="width: 100%; height: 100%; overflow : auto;"
    $jsvar = (isset($_REQUEST['noresize'])) ? '' : '&noresize=1';
    if ($mode == "online") { ?>
<script type="text/javascript">
/* <![CDATA[ */
setInterval('self.location.href=self.location.href + "<?php echo $jsvar ?>"', <?php echo $GLOBALS["buddylistrefresh"] ?>);
/* ]]> */
</script>
<?php }
    if (empty($_REQUEST['noresize'])) { ?>
<script type="text/javascript">
/*<![CDATA[*/
    window.resizeTo(240,<?php echo $winheigth ?>);
/*]]>*/
</script>
<?php }

    ?>
<a id="gotop"></a>
<table width="100%" border="0" cellspacing="2" cellpadding="0">
<tr>
<th colspan="3" title="<?php echo mxUndoNltobr(strip_tags(_PMSDISCRIBE, '<br>')) ?>" style="cursor: help;"><?php echo _PMSTITLE ?></th>
</tr>
<tr>
<td align="center" nowrap="nowrap"><?php echo $linking ?></td>
</tr>
<tr>
<td height="175" colspan="3">
<div class="border-t align-left"id="list" style="height: 175px; width: 100%; overflow: auto; font-size: 11px; padding-top: 2px;">
<ol start="1"><?php echo $listing ?></ol>
</div></td>
</tr>

<?php if ($mode != "online") { ?>
<tr><td colspan="3"><div class="border-t align-justify" id="refs" style="overflow: visible; font-size: 11px; padding-top: 8px; text-decoration: none;">
<?php echo $ref ?>
</div></td></tr>
<?php }

    ?>
</table>
<iframe src="<?php echo $filebuddyfoot ?>" name="check" id="check" width="0" height="0" marginwidth="0" marginheight="0" scrolling="no" frameborder="0" style="visibility: hidden;"></iframe>
<?php
    create_footerforall();
}

function closewindow()
{
    echo "<html>\n<head>\n<script type=\"text/javascript\">\n/* <![CDATA[ */\nwindow.close();\n/* ]]> */\n</script>\n</head>\n<body>\n</body>\n</html>";
    die();
}

function create_refreshJS($refreshtime)
{
    $content = "";
    if ($refreshtime > 0) {
        $content .= "<script type=\"text/javascript\">\n";
        $content .= "/* <![CDATA[ */\n";
        $content .= "	setInterval('self.location.href=self.location.href', " . $refreshtime . ")\n";
        $content .= "/* ]]> */\n";
        $content .= "</script>\n";
    }
    echo $content;
}

function notloggedin()
{
    global $url_images;

    create_headerforall(_PMSTITLE);
    create_bodyforall();
    echo "\n<br /><br />\n<br /><br /><center><font class=\"title\"><b>" . _PMSPLSLOGIN . "!</b></font><br /><br /><br />\n";
    echo '<a href="javascript:window.close()" onclick="window.close()">' . mxCreateImage($url_images . '/cancel.png', '', 0, 'style="background-color: transparent;"') . ' ' . _PMSCLOSE . '</a><br /><br />';
    create_footerforall();
    die("");
}

function notallowed()
{
    global $url_images;

    create_headerforall(_PMSTITLE);
    create_bodyforall();
    echo "\n<br /><br />\n<br /><br /><center><font class=\"title\"><b>" . _GROUPRESTRICTEDAREA . "!</b></font><br /><br /><br />\n";
    echo '<a href="javascript:window.close()" onclick="window.close()">' . mxCreateImage($url_images . '/cancel.png', '', 0, 'style="background-color: transparent;"') . ' ' . _PMSCLOSE . '</a><br /><br />';
    create_footerforall();
    die("");
}

/* ########### mainprog ####################################### */
if (empty($op)) $op = "buddy";
if (empty($ref_intervall)) {
    $ref_intervall = 0;
}
if (empty($subject)) $subject = "";
// mxdebugfuncvars($_POST);
switch ($op) {
    case "read":
        readm($msg_id);
        break;
    case "send":
        sendm($to, $to_userid, $message, $subject);
        break;
    case "compose":
        if (isset($deletemsg) && isset($msg_id)) {
            $result = sql_query("delete FROM {$prefix}_priv_msgs WHERE (to_userid='" . intval($GLOBALS["userinfo"]["uid"]) . "') AND (msg_id=" . intval($msg_id) . ") or (from_userid is null)");
        }
        if (isset($closewin)) {
            closewindow();
            die();
        } else {
            compose($to, $subject);
        }
        break;
    case "check":
        onlycheckmsg($ref_intervall);
        break;
    case "allusers":
        buddy("all");
        break;
    case "list":
        buddy();
        break;
    case "buddy":
        buddy();
        break;
    default:
        buddy();
        break;
}

?>